import java.awt.* ;
import javax.swing.* ;
import javax.swing.border.* ;
import java.applet.* ;
import java.awt.event.*;
import java.io.*;

public class Rezo extends Applet implements ActionListener //throws Exception
{
    public int etat ;
    Navigation navig ;
    static int MAX ;
    static Etat et ;
    static Token tok ;
    Paquet paquet ;
    Topologie topo ;

   void buildConstraints(GridBagConstraints gbc, int gx, int gy,
       int gw, int gh, int wx, int wy) {

       gbc.gridx = gx;
       gbc.gridy = gy;
       gbc.gridwidth = gw;
       gbc.gridheight = gh;
       gbc.weightx = wx;
       gbc.weighty = wy;
   }

    public void init () //throws Exception 
    {
/*
        Token tok = new Token () ;
 
        Etat et = (Etat)tok.infostout.elementAt (0) ;
        String Titre = et.info;
        MAX = tok.infostout.size () ;
        System.out.println ("MAX="+(tok.infostout.size ())+" Titre : "+Titre);
 
        for (int i = 1 ; i < tok.infostout.size () ; i++)
        {
            et = (Etat)tok.infostout.elementAt (i) ;
            System.out.println ("numet = " + et.numEtat + "     info = " +  et.info + " nb = "+ et.nb) ;
        }
*/
       GridBagLayout gridbag = new GridBagLayout();
       GridBagConstraints constraints = new GridBagConstraints();
       setLayout(gridbag);

       this.setBackground (Color.white);

       buildConstraints(constraints, 0, 0, 1, 1, 0, 20);
       constraints.fill = GridBagConstraints.NONE;
       constraints.anchor = GridBagConstraints.WEST;
       topo = new Topologie ();
       gridbag.setConstraints(topo, constraints);
       TitledBorder border = new TitledBorder ("Messages");
       border.setTitleFont (new Font ("Helvetica", 0, 10)) ;
//       topo.setBorder (border) ;
       add (topo);

       buildConstraints(constraints, 1, 0, 1, 1, 100, 80);
       constraints.fill = GridBagConstraints.NORTH;
       paquet = new Paquet ("Contrainte", this);
       TitledBorder border2 = new TitledBorder ("Contrainte");
       border2.setTitleFont (new Font ("Helvetica", 0, 10)) ;
//       paquet.setBorder (border2) ;
       gridbag.setConstraints(paquet, constraints);
       paquet.color = Color.red ;
       add (paquet);

       Paquet paquet2 = new Paquet ("Legende", this);
       paquet2.setBackground (Color.blue);
       TitledBorder border3 = new TitledBorder ("Legende");
       border3.setTitleFont (new Font ("Helvetica", 0, 10)) ;
//       paquet2.setBorder (border3) ;
       buildConstraints(constraints, 0, 1, 1, 1, 0, 0);
       constraints.fill = GridBagConstraints.NONE;
       constraints.anchor = GridBagConstraints.WEST;
       gridbag.setConstraints(paquet2, constraints);
       paquet2.color = Color.blue ;
       add (paquet2);

       navig = new Navigation (this);
       TitledBorder border4 = new TitledBorder ("Navigation");
       border4.setTitleFont (new Font ("Helvetica", 0, 10)) ;
//       navig.setBorder (border4) ;
       buildConstraints(constraints, 1, 1, 1, 1, 0, 0);
       constraints.fill = GridBagConstraints.EAST;
       gridbag.setConstraints(navig, constraints);
       add (navig);
    }

   public void actionPerformed(ActionEvent ev){
        if(ev.getSource().equals(navig.backButton)){
//            System.exit(0);
              etat = ((etat == 0) ? MAX - 1 : (etat - 1) % MAX) ;
          }
        else if(ev.getSource().equals(navig.forwardButton)){
              etat = (etat + 1) % MAX ;
        }

        et = (Etat)tok.infostout.elementAt (etat) ;
        paquet.label3.setText (et.info);
        topo.sens = ((et.nb == 1) ? true : false) ;
        super.repaint () ;
        topo.repaint () ;
    } 

    public static void main (String args []) throws Exception
    {
        if (args.length != 1)
        {
                System.out.println ("Usage : java Rezo <nom_data>");
                System.exit (0);
        }

        Frame frame = new Frame ("Rezo") ;
        frame.setSize (640, 480) ;

        Token tok = new Token (args [0]) ;

        et = (Etat)tok.infostout.elementAt (0) ;
        String Titre = et.info;
        MAX = tok.infostout.size () ;
        System.out.println ("MAX="+(tok.infostout.size ())+" Titre : "+Titre);

        for (int i = 1 ; i < tok.infostout.size () ; i++)
        {
            et = (Etat)tok.infostout.elementAt (i) ;
            System.out.println ("numet = " + et.numEtat + "     info = " +  et.info + " nb = "+ et.nb) ;
        }

        Rezo rezo = new Rezo () ;        
        rezo.setBackground (Color.white);
        rezo.init () ;
        frame.add (rezo) ;
        frame.setVisible (true) ;
    }
}
